import { Model } from 'mongoose';
import { Injectable, Inject } from '@nestjs/common';
import { Place } from './interfaces/place.interface';
import { CreateCatDto } from './dto/create-cat.dto';

@Injectable()
export class PlaceService {
  constructor(
    @Inject('PLACE_MODEL')
    private catModel: Model<Cat>,
  ) {}

  async create(createPlaceDto: CreatePlaceDto): Promise<Place> {
    const createdPlace = new this.placeModel(createPlaceDto);
    return createdPlace.save();
  }

  async findAll(): Promise<Place[]> {
    return this.placeModel.find().exec();
  }
}
